<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Intro to C Programming</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>

		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>
		<div class="reveal">
			<div class="slides">
				<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
					<h1>Intro to C Programming</h1>
					<p>39th Information Operations Squadron Detachment 1</p>				
				</section>
				
				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
					<h2>Introduction</h2>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
						instructor view!!
					</aside>
					</section>

					<section>
                        <h3>In This Lesson:</h3>
                        <ul>
                            <li>Terminology</li>
                            <li>Language Features</li>
                            <li>C Specifics</li>
                            <li>Setting Up The Environment</li>
                            <li>Documentation</li>
                        </ul>
                    </section>

                    <section>
                        <h3>By the end of this section you should:</h3>
                        <ul>
                            <li>Know how to setup your C programming environment on both Windows and Linux</li>
                            <li>The basics of the different text editors</li>
                            <li>Some basic programming definition</li>
                            <li>The general and specific features to the C Language (on a basic level)</li>
                        </ul>
                    </section>

                    <section>
						<h3>LESSON OBJECTIVES:</h3>
						<h3><a href="../Introduction/objectives.html" target="_blank">Link To Objectives</a></h3>
                    </section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h2>Programming Terminology</h2>
					</section>

					<section>
						<h3>High vs Low Level Programming Languages</h3>
						<br>
						<p><img alt="High vs Low Level Programming Languages" src="../assets/image2.png"></p>
					
						<p><span style="font-size:1em;"><a href="https://www.geeksforgeeks.org/difference-between-high-level-and-low-level-languages/" target="_blank">More Differences</a></span></p>					</section>
					
					<section>
						<h3>High Level Programming</h3>
						<p>Hello World in Python</p>
<pre><code class="python" data-line-numbers="">print("Hello, world!")</code></pre>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
                    </section>
                    
					<section>
						<h3>Low Level Programming</h3>
						<p>Hello World in Assembly</p>
<pre style="font-size: 0.45em"><code class="assembly" data-line-numbers="">SECTION .data
greeting     db      'Hello, World!', 0Ah 
							
SECTION .text
global  _start
							
_start:
							
mov     edx, 14
mov     ecx, greeting
mov     ebx, 1
mov     eax, 4
int     80h

mov     ebx, 0
mov     eax, 1
int     80h
</code></pre>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>

					<section>
						<h3>C Programming</h3>
						<p>Hello World in C</p>
<pre><code class = "c" data-line-numbers="">#include &lt;stdio.h&gt;

int main(){
    printf("Hello, World!");
    return 0;
}
</code></pre>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>

					<section>
						<h3>Blocks - {...}</h3>
<pre><code class = "c">if (something)
{
    if (somethingElse) {
        //do something
    }
}
else if (somethingOther){
    //do something
}
else{
    //do nothing
}
</code></pre>

						<aside class="notes">
							A block is a group of executable statements.
						</aside>
					</section>

					<section>
						<h3>Functions</h3>
<pre><code class="c" data-line-numbers="">int addNumbers(int a, int b)
{
    return a + b;
}
</code></pre>
						<aside class="notes">
							A function is a block of code written to perform a specific task.
						</aside>
					</section>

					<section>
						<h3>Statements, Declarations, and Definitions</h3>
<pre style="font-size: 0.4em"><code class="c" data-line-numbers="">int foo(double);                  // function declaration (prototype)
int foo(double x){ return x; }    // function definition

double d;                         // declaration
d = 39.0;                         // expression statement

int main(void)                    // start of function definition
{                                 // start of compound statement
  int n = 1;                      // definition
  n += 1;                         // expression statement
  for(int i = 0; i &lt; 5; i++)      // iteration statement
  {                               // start of compound statement
    printf("n = %d\n", n);        // expression statement
    if (n > 0)                    // selection statement
    {                             // start of compound statement
      break;                      // jump statement
    }                             // end of compound statement
  }                               // end of compound statement
  return 0;                       // jump statement
}                                 // end of compound statement &amp; function definition
</code></pre>
						<p style="font-size: 0.4em">Explore more:<br> 
							<a href = "https://en.cppreference.com/w/c/language/statements" target = "_blank">Statements - cppreference.com</a> <br>
							<a href = "https://en.cppreference.com/w/c/language/declarations" target = "_blank">Declarations - cppreference.com</a> <br>
							<a href = "https://docs.microsoft.com/en-us/cpp/c-language/c-language-reference" target = "_blank">C Language Reference - Microsoft</a>
						</p>

						<aside class="notes">
							Statements are snippets of code that do things. They are human readable text that a compiler will turn into executable statements when compiled.
						</aside>
					</section>

					<section>
						<h3>Scope</h3>
<pre style="font-size: 0.34em"><code class="c" data-line-numbers="">#include &lt;stdio.h&gt;
int x = 20; // Global variable
int someFunction();
  
int main(){
    int y = 30; // Local variable
    someFunction();
    return 0;
}
  
int someFunction() {
    printf("%i\n", x);    // Can access x here
    printf("%i\n", y);    // ERROR: Cannot access y here.

    for(int i=0; i!=5; i++){ 
        printf("%i ", i);   // Can access i here
    }
    printf("%i\n", i);    // ERROR: Cannot access i here.

    int x = 10;           // Is this an error?
    int x = 5;            // What about this?
    printf("\n%i\n", x);  // What prints here?
    return 0;
}
</code></pre>

						<aside class="notes">
							Scope is the level at which a piece of data or function is visible.
						</aside>
					</section>


					<section>
						<h3>Whitespace Characters</h3>
					
						<ul>
							<li>Spaces (' ')</li>
							<li>Tabs ('\t')</li>
							<li>Newline ('\n')</li>
							<li>Vertical Tab('\v')</li>
							<li>Carriage Return('\r')</li>
						</ul>
						<aside class="notes">
							Whitespace are tabs, spaces and newline/End of Line (EOL) characters that separate text characters in source code. 
							In other words, any character or series of whitespace characters that represent horizontal or vertical space.
						</aside>
					</section>

					
					<section>
						<h3>Text Editors</h3>
						<p>In this class, we will use <a href="https://github.com/microsoft/vscode">VS Code</a> our primary text editor.:</p>
						<p>Some other text editors you can explore are:</p>
						<ul>
							<li><a href="https://github.com/atom/atom">Atom</a></li>
							<li><a href="https://www.sublimetext.com/">Sublime Text (not Open Source)</a></li>
							<li><a href="https://git.savannah.gnu.org/cgit/nano.git/tree/README.GIT">Nano</a></li>
							<li><a href="https://github.com/vim/">Vi/Vim</a></li>
						</ul>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

					<section>
						<h3>Integrated Development Environment (IDE)</h3>
						<p> In this class we will use <b>Visual Studio</b></p>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h2>C Language Features</h2>
					</section>

					<section>
						<h3>Whitespace (What is it good for?)</h3>
						<p>C is a <a href = "https://en.wikipedia.org/wiki/Free-form_language" target=_blank>free-form</a> language. 
<pre><code class="c" data-line-numbers="">int(i);printf("Integer?\n");scanf("%d",&amp;i);i=i/10;

// vs

int i ;
printf( "Integer?\n" )
      ;
scanf(   "%d"   , &amp;i   )   ;
i = i / 10;
</code></pre>
					<aside class="notes">
						Add notes here.
					</aside>
					</section>

					<section>
						<h3>Main</h3>
						<p>All program execution begins and ends with main. If another function is called, it must be done inside of main.</p>
<pre><code class="c" data-line-numbers="">int main(){
    myFunction();
    return 0;
}
</code></pre>
					</section>

					<section>
						<h3>Data Types</h3>
                        <img src="../assets/VarTypes.png" alt="Data types">
						<p>References:<br>
							<a href="https://en.cppreference.com/w/c/language/type" target=_blank>cppreference.com</a><br>
							<a href="https://en.wikipedia.org/wiki/C_data_types" target=_blank>Wikipedia</a>
						</p>
					</section>
					<section>
						<h3>Data Types NOT in C...</h3>
						<table>
							<tbody>
								<tr>
									<th>Python Type</th>
									<th>Similarly Used in C</th>
								</tr>
								<tr>
									<td>boolean (True/False)</td>
									<td>int (0==False, 1==True)</td>
								</tr>
								<tr>
									<td>list</td>
									<td><em>array</em> [...]</td>
								</tr>
								<tr>
									<td>string</td>
									<td>char <em>array</em> [...]</td>
								</tr>
								<tr>
									<td>set</td>
									<td>n/a</td>
								</tr>
								<tr>
									<td>dictionary (dict)</td>
									<td>n/a</td>
								</tr>
							</tbody>
						</table>
					</section>
					<section>
                        <h3>Array</h3>
                        <p style="font-size: 0.4em">A collection of values of the same data type stored in memory.</p>
                        <img src="../assets/array1.png" alt="Array of ints">
                        <aside class="notes">
                            ints are 4 bytes in this example
                        </aside>
<pre><code class="c" data-line-numbers="">int myArray[] = {0,1,1,2,3};

int x = myArray[3]; // what does x = ?
myArray[0] = 42;    // what changed in the array?
x = myArray[10];    // what happens?

double values[100];
</code></pre>
                    </section>

                    <section>
                        <h3><del>String</del> An array of chars</h3>
                        <img src="../assets/string1.png" alt="Array of chars">
                        <aside class="notes">
                            Add notes here
                        </aside>
<pre><code class="c" data-line-numbers="">char str[] = "Will";

//or

char str[5] = {'W','i','l','l','\0'};
</code></pre>
					</section>
					
                    <section>
                        <h3>Structures</h3>
                        <p>A group of variables.</p>
<pre><code class="c" data-line-numbers="">struct birthday {       // defining the type birthday
	int day;
	int month;
	int year;
}

struct birthday b_day;  // declare b_day of type birthday
b_day.day = 2; b_day.month = 29; b_day.day = 2000; 

struct birthday epoch = {1, 1, 1970};
</code></pre>
                        <aside class="notes">
                            Add notes here
                        </aside>
                    </section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h2>C Specifics</h2>
					</section>

					<section>
						<h3>Pointers</h3>
						<p>Variables that store a memory address of data.
							<a href="https://xkcd.com/138/"><img src="../assets/pointers_xkcd.png" alt="Pointers from xkcd"></a>
						</p>
						<aside class="notes">
							Add notes here
						</aside>
<pre><code class="c" data-line-numbers="">int *i_ptr;    // a pointer to an integer
double *d_ptr; // a pointer to a double
char *str;     // a pointer to a char
</code></pre>
					</section>

				<section>
					<h3>Dynamic Memory Allocation</h3>
<pre><code class="c" data-line-numbers="">int *func()
{
    int *x = malloc(1024); // Allocate one kb
    return x;
}

int *x = func(); // still allocated after function end

free(x); // free to prevent crash
</code></pre>
					<p> See: <br>
						<a href="https://en.cppreference.com/w/c/memory/malloc" target="_blank">malloc</a><br>
						<a href="https://en.cppreference.com/w/c/memory/calloc" target="_blank">calloc</a>
					</p>
					<aside class="notes">
						The malloc() function allocates size bytes and returns a pointer to
						the allocated memory.  The memory is not initialized.
					</aside>
				</section>

				<section>
					<h3>Comments in C</h3>
<pre><code class="c" data-line-numbers="">// This is a comment in C

/* This is a 
   multiline
   comment in C */
</code></pre>
					<aside class="notes">
						Add notes here
					</aside>
				</section>

				<section>
					<h3>Filenames</h3>
					<ul>
						<li>Source Code (.c)</li>
						<li>Header Files (.h)</li>
						<li>Object Files (.o)</li>
					</ul>
					<aside class="notes">
						"Object" in this case does NOT refer to OOP.
					</aside>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
			data-background-position="top 5% left 5%">
				<section>
					<h2>Setting up C</h2>
				</section>

				<section>
					<h3>Compiling C</h3>
					<p>C is a <b>compiled language</b>, our code is actually "translated" into machine code before it is run.</p>
				</section>

				<section>
					<h3>Installing a compiler</h3>
					<ul>
						<li>Windows: <a href="https://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win32/Personal%20Builds/mingw-builds/installer/mingw-w64-install.exe/download" target="_blank">MinGW-x64</a></li>
						<li>Linux: <a href=https://gcc.gnu.org target="_blank">GCC</a></li>
					</ul>
				</section>

				<section>
					<h3>GNU Complier Collection (GCC)</h3>
					<p>To compile with GCC:</p>
<pre><code class="bash">gcc hello.c</code></pre>
					<p>To run the executable:</p>
<pre><code class="bash">./a.out</code></pre>
					<aside class="notes">
						
					</aside>
				</section>

				<section>
					<h3>Additional Compilation Utilities</h3>
					<p>make - Makefile.txt</p>
<pre><code class="bash">make
make build
make clean
make run
</code></pre>

					<p>CMake - CMakeLists.txt</p>
<pre><code class="bash">cmake .
cmake --build .
</code></pre>

					<aside class="notes">
					
					</aside>
				</section>

				<section>
					<h3>Setting up VSCode to Run C</h3>
					<ul>
						<li>VS Code Windows <a href="https://code.visualstudio.com/docs/cpp/config-mingw">Walkthrough</a></li>
						<li>VS Code Linux <a href="https://code.visualstudio.com/docs/cpp/config-linux">Walkthrough</a></li>
						<li>VS Code WSL <a href="https://code.visualstudio.com/docs/cpp/config-wsl">Walkthrough</a></li>
						<li>Extension <a href=https://marketplace.visualstudio.com/items?itemName=ms-vscode.cpptools>here</a></li>
						<li>Or search C C++ the Extensions in VSCode</li>
					</ul>
				</section>

				<section>
					<h3>Greetings, Universe!</h3>
<pre><code class="c" data-line-numbers="">// Hello World is thinking too small. We need ambition!
// We want to greet the enitre Universe

#include &ltstdio.h&gt

int main() {
	printf("Greetings, Universe!");
	return 0;
}
</code></pre>
				<a href="https://www.onlinegdb.com/online_c_compiler" target="_blank">Online C Compiler</a>
				</section>

			
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
			data-background-position="top 5% left 5%">

				<section>
					<h2>Documentation</h2>
				</section>

				<section>
					<h3>MSDN Documentation</h3>
					<p>The Microsoft Documentation for the C Language is available <a href=https://docs.microsoft.com/en-us/cpp/c-language/c-language-reference?view=vs-2019>here</a>.</p>
					<aside class="notes">
						
					</aside>
				</section>

				<section>
					<h3>Linux Man Pages</h3>
					<p>From the command line, try:</p>
					<ul>
						<li>man stdio</li>
						<li>man malloc</li>
						<li>man printf</li>
						<li>man string</li>
						<li>man man</li>
					</ul>
					<p><a href = "https://man7.org/linux/man-pages/man1/man.1.html">Or go online.</a></p>
					<aside class="notes">
						Sample Aside information
	
					</aside>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h2>Review</h2>
						<h2>&amp;</h2>
						<h2>Questions</h2>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
						instructor view!!
					</aside>
					</section>

					<section>
                        <h3>In This Lesson:</h3>
                        <ul>
                            <li>Terminology</li>
                            <li>Language Features</li>
                            <li>C Specifics</li>
                            <li>Setting Up The Environment</li>
                            <li>Documentation</li>
                        </ul>
                    </section>
				</section>
			</div>
		</div>

		
			
		<!-- DO NOT TOUCH -->
		<script src="js/reveal.js"></script>

		<script>
			Reveal.initialize({
				slideNumber: true,
				hash: true,
				menu: {
					side: 'left',
					width: 'normal',
					numbers: true,
					titleSelector: 'h1, h2, h3, h4, h5, h6',
					useTextContentForMissingTitles: false,
					hideMissingTitles: false,
					markers: true,
					custom: false,
					themes: true,
					themesPath: 'css/theme/',
					transitions: true,
					openButton: true,
					openSlideNumber: true,
					keyboard: true,
					sticky: true,
					autoOpen: true,
					delayInit: false,
					openOnInit: false,
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
			Reveal.configure({slideNumber: true})
		</script>
	</body>
</html>
